// Loesung von Aufgabe 15 aus Kapitel 7
function y = rechteck(x); y = sign(x/2 - round(x/2)); endfunction;
// Berechnung der Integrale fuer die Koeffizienten
// Die Kosinusterme verschwinden aufgrund der Antisymmetrie von rechteck,
// es bleiben die Sinus-Koeffizienten b_n
T = 2;               // Schwingungsdauer
N = 10;              // Zahl der Harmonischen
b = zeros(N, 1);     // Vektor fuer die Koeffizienten
for I = 1:N
  //f = @(t) rechteck(t).*sin(I*pi*t);
  function y = f(t); y = rechteck(t).*sin(I*%pi*t); endfunction;
  b(I) = 2/T*intg(0, T, f, 1e-8);
end

// Ausgabe der Koeffizienten
plot2d3(1:N,b)
plot(1:N, b, '*')
h1 = gca();
h1.data_bounds = [-0.1, 0; 10.1, 1.4];
input('Press <ENTER> to continue')

// Berechnung von Zeitreihen fuer 10 Harmonische und Summation
// geht einfach als Summe ueber 10 explizite Zeitreihen
// Trick: Alle Werte in einem Array der Form (10, NT)
t = -2.5:0.01:2.5;
x = b'*sin(%pi*(1:N)'*t);
xdel();         // altes Fenster löschen
plot(t, x)
